SystemOrganization addCategory: #'Rizel-Spy-Profiler'!

PackageSpy subclass: #MPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler'!

!MPackage class methodsFor: 'as yet unclassified' stamp: ''!
spyClassForClass
	^ MClass! !

MethodSpy subclass: #MMethod
	instanceVariableNames: 'numberOfExecutions numberOfCalls depthMax depthMin isRelevantCache argumentTable performLocalSideEffect receiverTable returnValueTable sameReturnValuePerReceiverBoolean returnSelf numberOfDifferentReceiversAtLeastCache copySourceCode tally numberOfCallsMajor numberOfLookedUpMethods numberOfLookedUpMethodsMajor'
	classVariableNames: 'CallerMethod'
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler'!

!MMethod class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:20'!
resetCallerMethod
	CallerMethod := nil! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:44'!
argumentTable
	^ argumentTable ifNil: [
		argumentTable := Array new:  4096
	]! !

!MMethod methodsFor: 'accessing' stamp: 'JPSA 6/18/2012 21:37'!
className
	^ self classSpy className.! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 23:06'!
copySourceCode
	^ copySourceCode ! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:44'!
depthMax 
	^ depthMax ! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:44'!
depthMin 
	^ depthMin! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/10/2012 15:10'!
executionTime: aNumber
	super executionTime: aNumber.
	tally := true.! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:08'!
fractionOfTotalExecution
	^ (self numberOfEmittedCalls / self profiler numberOfCalls) asFloat ! !

!MMethod methodsFor: 'accessing-primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:09'!
getNumberOfCalls
	<primitive: 556>
	self primitiveFailed! !

!MMethod methodsFor: 'accessing-primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:09'!
getNumberOfEmittedCallsMajor
	<primitive: 560>
	self primitiveFailed! !

!MMethod methodsFor: 'accessing-primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:09'!
getNumberOfLookedUpMethods
	<primitive: 554>
	self primitiveFailed! !

!MMethod methodsFor: 'accessing-primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:10'!
getNumberOfLookedUpMethodsMajor
	<primitive: 559>
	self primitiveFailed! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
hasAlwaysTheSameReturnValue
	^ (self returnValueTable select: #notNil) asSet size = 1! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:45'!
hasSameReturnValuePerReceiver
	^ sameReturnValuePerReceiverBoolean  ! !

!MMethod methodsFor: 'support private' stamp: 'JuanPabloSandovalA 6/9/2012 16:47'!
increaseNumberOfCalls

	numberOfCalls := numberOfCalls + 1! !

!MMethod methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:11'!
initialize
	super initialize.
	executionTime := 0.
	performLocalSideEffect := false.
	numberOfCalls := 0.
	depthMin := 0.
	depthMax := 0.
	sameReturnValuePerReceiverBoolean := true.

	returnSelf := false.
	tally := false.

	numberOfExecutions := 0.
	numberOfLookedUpMethods := 0.
	numberOfCallsMajor := 0.
	numberOfLookedUpMethodsMajor := 0.! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 22:11'!
isCovered
	^ true! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
isLeaf
	^ self outgoingCalls isEmpty! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
isNotLeaf
	^ self isLeaf not! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:08'!
numberOfCalls
	^ numberOfCalls + (numberOfCallsMajor * SmallInteger maxVal)! !

!MMethod methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 6/9/2012 16:49'!
numberOfDifferentReceiversAtLeast
	numberOfDifferentReceiversAtLeastCache ifNotNil: [ ^ numberOfDifferentReceiversAtLeastCache ].
	^ numberOfDifferentReceiversAtLeastCache := (self receiverTable select: #notNil) size! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:08'!
numberOfEmittedCalls
	^ numberOfCalls + (numberOfCallsMajor * SmallInteger maxVal)! !

!MMethod methodsFor: 'metrics' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 22:02'!
numberOfExecutions
	^ numberOfExecutions.! !

!MMethod methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 6/9/2012 16:49'!
numberOfIncomingCalls
	^ self incomingCalls size! !

!MMethod methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 6/9/2012 16:49'!
numberOfOutgoingCalls
	^ self outgoingCalls size! !

!MMethod methodsFor: 'hooks' stamp: 'JuanPabloSandovalA 6/9/2012 23:05'!
originalMethod: aCompiledMethod
	super originalMethod: aCompiledMethod.
	copySourceCode  := self sourceCode.! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
performLocalSideEffect
	^ performLocalSideEffect! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
performSideEffect
	^ self withAllOutgoingCalls anySatisfy: #performLocalSideEffect 
	
	"^ self performSideEffectRoot: self"! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
performSideEffectRoot: aProfilingMethodSpy
	
	self isLeaf ifTrue: [ ^ self performLocalSideEffect ].
	
	^ self outgoingCalls anySatisfy: [:outgoingCall |
		outgoingCall == aProfilingMethodSpy ifTrue: [ ^ outgoingCall performLocalSideEffect ].
		outgoingCall performSideEffectRoot: aProfilingMethodSpy
	]! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
performsSideEffect

	^ self withAllOutgoingCalls anySatisfy: #performLocalSideEffect! !

!MMethod methodsFor: 'printing' stamp: 'JuanPabloSandovalA 6/9/2012 16:50'!
printOn: stream 
	super printOn: stream.
	stream nextPut: $ .
	stream nextPutAll: executionTime printString.
	stream nextPutAll: ' ms '.
	self profiler ifNil: [ ^ self ].
	self profiler totalExecutionTime ifNil: [ ^ self ].

	self profiler totalExecutionTime > 0
		ifTrue: [ 
			stream nextPut: $(.
			stream nextPutAll: (executionTime * 100 / self profiler totalExecutionTime) asInteger printString.
			stream nextPut: $%.
			stream nextPut: $) ].
	
	stream nextPutAll: ('<n>executed <1p> time<2s> <n>' expandMacrosWithArguments: {self numberOfCalls . (self numberOfCalls > 1) ifTrue: ['s']ifFalse: [''] }).
"	self isRelevant 
		ifTrue: [ stream cr. stream nextPutAll: ' above time threshold' ].
"		
	self performSideEffect
		ifFalse: [ stream cr. stream nextPutAll: ' performs no side effect' ].
		
"	self hasSameArgumentsPerReceiver 
		ifTrue: [ stream cr. stream nextPutAll: ' and has same arguments per receiver' ].
"
	stream cr.
	stream nextPutAll: 'invoked on at least '.
	stream nextPutAll: self numberOfDifferentReceiversAtLeast printString.
	stream nextPutAll: ' receiver'.
	self numberOfDifferentReceiversAtLeast > 1
		ifTrue: [ stream nextPut: $s ].

	self hasSameReturnValuePerReceiver 
		ifTrue: [ stream cr; nextPutAll: 'same return value per receiver'].

	! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:45'!
receiverTable
	^ receiverTable ifNil: [
		"receiverTable := Array new:  4096"
		receiverTable := BoundedDictionary new.
	]! !

!MMethod methodsFor: 'accessing-primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:10'!
resetNumberOfCalls
	<primitive: 557>
	self primitiveFailed! !

!MMethod methodsFor: 'accessing-primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:10'!
resetNumberOfLookedUpMethods
	<primitive: 555>
	self primitiveFailed! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:45'!
returnSelf
	^ returnSelf! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:45'!
returnValueTable
	^ returnValueTable ifNil: [
		"returnValueTable := Array new:  4096"
		returnValueTable := BoundedDictionary new.
	]! !

!MMethod methodsFor: 'hooks' stamp: 'JuanPabloSandovalA 6/12/2012 00:02'!
run: aSelector with: aListOfArguments in: aReceiver

	"| v receiverSnapshot returnValueHash receiverHash identityHash argAndReceiverSnapshot |"

	| oldNumberOfEmittedCalls v oldNumberOfEmittedCallsMajor |

	[
	copySourceCode  := self sourceCode printString.
	numberOfExecutions := numberOfExecutions + 1.
	oldNumberOfEmittedCallsMajor := self getNumberOfEmittedCallsMajor.
	oldNumberOfEmittedCalls := self getNumberOfCalls.
	] on:Error do:[Transcript show:'error';cr.].
	
	"receiverSnapshot := aReceiver snapshotAsInteger.
	identityHash := aReceiver identityHash."
"	(identityHash > 4096) ifTrue: [ identityHash := identityHash bitShift: -18 ]."
	"receiverHash := identityHash+ 1."

	"SIDE EFFECT"
	"performLocalSideEffect ifFalse: [
		argAndReceiverSnapshot := receiverHash bitXor: aListOfArguments snapshotAsInteger.
		(self receiverTable includesKey: receiverHash) 
			ifTrue: [ (self receiverTable at: receiverHash) ~= argAndReceiverSnapshot
						ifTrue: [ performLocalSideEffect := true ]]
			ifFalse: [ self receiverTable at: receiverHash put: argAndReceiverSnapshot ]]."
	
	"METHOD EXECUTION"
	v := super run: aSelector with: aListOfArguments in: aReceiver.
	[
	numberOfCalls := (self getNumberOfCalls - oldNumberOfEmittedCalls) + numberOfCalls - 5 .
	numberOfCallsMajor := (self getNumberOfEmittedCallsMajor - oldNumberOfEmittedCallsMajor) + numberOfCallsMajor.
	] on: Error do:[ Transcript show:'error 2';cr.].
	"SIDE EFFECT"
	"aReceiver snapshotAsInteger ~= receiverSnapshot
		ifTrue: [ performLocalSideEffect := true ]."
	
	"RETURN VALUE"
	"returnValueHash := v identityHash.
	(self returnValueTable includesKey: receiverHash) 
		ifTrue: [ (self returnValueTable at: receiverHash) ~= returnValueHash 
					ifTrue: [ sameReturnValuePerReceiverBoolean := false ]].
	self returnValueTable at: receiverHash put: returnValueHash.
	(aReceiver == v) ifTrue: [ returnSelf := true ]."
	
	^ v! !

!MMethod methodsFor: 'accessing-primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:10'!
setNumberOfEmittedCalls: integer
	<primitive: 558>
	self primitiveFailed! !

!MMethod methodsFor: 'utils' stamp: 'JuanPabloSandovalA 6/9/2012 16:50'!
useTime: aTally parents: parents

	aTally time ifNil: ["Transcript cr; show: 'the time is still nil:'; show: self printString. executionTime := 700." ^self].
	
	executionTime := aTally time.
	
	executionTime > 0 ifTrue: [(parents anySatisfy: [:e | e method == aTally method]) ifTrue: [depthMax := parents size. ^self]].
	"executionTime := executionTime + aTally time."
	depthMin := parents size! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/10/2012 15:10'!
wasTally
	^ tally.! !

Profiler subclass: #MProfiler
	instanceVariableNames: 'inputs dimensions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler'!

!MProfiler class methodsFor: 'primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:05'!
getNumberOfCalls
	<primitive: 556>
	self primitiveFailed! !

!MProfiler class methodsFor: 'util' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:06'!
numberOfCallsIn: aBlock
"
	self new numberOfCallsIn: [ 10 yourself; yourself; yourself ]
	self new numberOfCallsIn: [  10  log ]
	self new numberOfCallsIn: [ '1' , '2']
	
	self new numberOfCallsIn: [ '1' , '2']
	
	|s|
	s := Set new.
	Compteur new numberOfCallsIn: [ 1000 timesRepeat: [s add: Object new]]   
	56259
	56415
	54383 55997 56165
"	
	| t |
	t := self resetNumberOfCalls.
	aBlock value.
	"-3 is the number of messages sent by an empty block. "
	^ (self getNumberOfCalls - 3) / 2! !

!MProfiler class methodsFor: 'primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:05'!
resetNumberOfCalls
	<primitive: 557>
	self primitiveFailed! !

!MProfiler class methodsFor: 'hooks' stamp: ''!
spyClassForPackage
	^ MPackage! !

!MProfiler methodsFor: 'accessing - read only' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:01'!
allCoveredClasses
	^ self allClasses select: #isCovered! !

!MProfiler methodsFor: 'accessing - read only' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:02'!
allCoveredMethods
	^ self allMethods select: #isCovered! !

!MProfiler methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:03'!
beforeProfiling
	CompteurMethod 
		resetCallerMethod.
	self
		resetNumberOfLookedUpMethods;
		resetNumberOfCalls! !

!MProfiler methodsFor: 'primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:04'!
getNumberOfCalls
	^ self class getNumberOfCalls! !

!MProfiler methodsFor: 'hooks' stamp: 'JuanPabloSandovalA 6/9/2012 16:42'!
getTimeAndCallGraph
	^ true! !

!MProfiler methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalA 6/9/2012 16:43'!
initialize 
	super initialize.
	totalExecutionTime := 1.! !

!MProfiler methodsFor: 'accessing - read only' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:02'!
numberOfCalls
	^ self allMethods inject: 0 into: [ :sum :el | sum + el numberOfEmittedCalls ]! !

!MProfiler methodsFor: 'util' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:04'!
numberOfCallsIn: aBlock
	^ self class numberOfCallsIn: aBlock! !

!MProfiler methodsFor: 'accessing - read only' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:03'!
numberOfEmittedCalls
	^ self allMethods inject: 0 into: [ :sum :el | sum + el numberOfEmittedCalls ]! !

!MProfiler methodsFor: 'hooks' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:03'!
registryName
	^ #MProfiler! !

!MProfiler methodsFor: 'util' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:04'!
resetNumberOfCalls
	^ self class resetNumberOfCalls! !

!MProfiler methodsFor: 'primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:04'!
resetNumberOfLookedUpMethods
	<primitive: 555>
	self primitiveFailed! !

!MProfiler methodsFor: 'primitives' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:04'!
setNumberOfEmittedCalls: integer
	<primitive: 558>
	self primitiveFailed! !

!MProfiler methodsFor: 'hooks' stamp: 'JPSA 6/21/2012 01:22'!
tallyOn: aBlock
	
	| tally |
	tally := Sampling new.
	tally spyEvery: 1 on: [ 20 timesRepeat: aBlock].
	^ tally! !

!MProfiler methodsFor: 'accessing - read only' stamp: 'JuanPabloSandovalA 6/9/2012 16:42'!
totalExecutionTime
	^ totalExecutionTime ! !

ClassSpy subclass: #MClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler'!

!MClass class methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 16:06'!
isCovered
	^ self methods anySatisfy: #isCovered! !

!MClass class methodsFor: 'hooks' stamp: ''!
spyClassForMethod
	^ MMethod! !

!MClass methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:43'!
isCovered
	^ self allMethods anySatisfy: #isCovered! !
